<template>
  <div v-if="isLoading">Loading ......</div>
  <div v-else>
    <div v-for="item in getItemsList" :key="item.id">
      {{ item.dishName }} - {{ item.measurementUnit }} - {{ item.costPerUnit }} - {{ item.cuisine }}
      <button @click="deleteItem(item.id)">Delete</button>
      <button @click="show(item)">Show</button>
    </div>
    <hr />
    <div v-if="showItem">
      <h2>Selected Dish</h2>
      <p>{{ selectedDish.dishName }} - {{ selectedDish.measurementUnit }} - {{ selectedDish.costPerUnit }} - {{ selectedDish.cuisine }}</p>
    </div>
    <div>
      
      <button @click="goToAddPage">Add</button>
    </div>
    <hr />
    <div>
  Nationality Filter
  <select v-model="selectedNationality">
    <option value="">All</option>
    <option v-for="nationality in uniqueNationalities" :key="nationality" :value="nationality">
      {{ nationality }}
    </option>
  </select>
</div>
<button @click="loadFilteredDataByNationality">Filter</button>
    <div>
      Dish to found
      <input v-model="targetDishName" type="text" />
    </div>
    <button @click="loadFilteredDataByDish">Filter</button>
    
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';

export default {
  name: 'DishList',
  data() {
    return {
      product: {},
      showItem: false,
      selectedDish: {},
      selectedNationality: 'All',
      targetDishName: ''
    };
  },
  computed: {
    ...mapGetters('products', ['getItemsList', 'isLoading']),
    uniqueNationalities() {
  const nationalitiesSet = new Set();
  this.getItemsList.forEach((item) => {
    if (item && item.cuisine && typeof item.cuisine === 'string' && item.cuisine.trim() !== "") {
      nationalitiesSet.add(item.cuisine.trim());
    }
  });

  const uniqueNationalitiesArray = Array.from(nationalitiesSet);
  console.log('All Nationalities:', this.getItemsList.map(item => item && item.cuisine ? item.cuisine.trim() : ''));
  console.log('Unique Nationalities:', uniqueNationalitiesArray);

  return uniqueNationalitiesArray;
},
  },
  created() {
    this.loadList();
  },
  methods: {
    ...mapActions('products', ['loadList', 'addItem', 'deleteItem', 'updateItem', 'loadFilteredData']),
    


  loadFilteredDataByNationality() {
  if (this.selectedNationality.trim() !== "") {
    this.loadFilteredData({
      fieldTitle: 'cuisine',
      compareOperator: '==',
      valueToCompare: this.selectedNationality,
    });
  } else {
    this.loadList(); 
  }
},
    
  loadFilteredDataByDish() {
  if (this.targetDishName.trim() !== "") {
    this.loadFilteredData({
      fieldTitle: 'dishName',
      compareOperator: '==',
      valueToCompare: this.targetDishName,
    });
  } else {
    this.loadList(); 
  }
},
    
    goToAddPage(){
      this.$router.push('/dishForm');
    },
    
    show(item) {
      this.showItem = true;
      this.selectedDish = { ...item };
    },
    loadList() {
    this.$store.dispatch('products/loadList');
  },
  },
};
</script>

<style lang="scss" scoped>

</style>
